import { Button, Descriptions, Popconfirm, Row, Col, Form, Modal, Input, Select, Table } from 'antd';
import React from 'react';
import { initFilter, extendRule, extendInclude, extendIgnoreDataRule, setDataFieldValue, guid, initQueryFilter } from "../../../utils/common";
import ReactToPrint from "react-to-print";
import stylesStep from '../HI/StepForm.css';
import config from "../../../config";
import XLSX from 'xlsx';
import { connect } from 'dva';
import moment from 'moment';
import { message } from "antd/lib/index";
import FormPage from '../../../components/FormPage'
class DM012ShowPrint extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            data: null,
            BtnAgreeDisplay: 'none',
            tmpData: {},
        };
    };

    componentDidMount() {
        if (this.props.data?.id)
            this.loadData(this.props.data?.id);
    }

    componentWillReceiveProps(NextProps) {
        if (NextProps.data?.id && this.props.data?.id != NextProps.data?.id) {
            this.loadData(NextProps.data?.id);
        }
    }

    onTableBtnAgree() {
        this.props.dispatch({
            type: 'app/getDataByPost',
            url: 'PE/PECorrectivePreventive/IdentityUpdate',
            payload: {
                ID: this.props.data.id,
                TaskID: this.props.data.TaskID,
            },
            onComplete: (ret) => {
                if (ret) {
                    message.success('确认成功！');
                    this.setState({ BtnAgreeDisplay: 'none' })
                    this.BtnClose();
                }
            }
        })
    }

    BtnClose = () => {
        if (typeof this.props.data.onCancel != "undefined" && typeof this.props.data.onCancel == 'function')
            this.props.data.onCancel();
    }

    loadData = (dataId) => {
        let that = this;
        let json = initFilter(that.props.login.OrgId);
        extendRule(json, 'ID', 1, dataId);
        extendInclude(json, 'Nav_User');
        extendInclude(json, 'Nav_Department');
        extendInclude(json, 'Nav_DeviceBase');
        extendInclude(json, 'Nav_Files');
        extendInclude(json, 'Nav_Files.Nav_ImgFile');
        extendInclude(json, 'Nav_Files.Nav_ImgFile.Nav_File');
        extendIgnoreDataRule(json)
        that.props.dispatch({
            type: 'app/getDataByPost',
            payload: json,
            url: 'DM/DetectionInspectionRecord/Get',
            onComplete: (ret) => {
                if (ret) {
                    that.setState({ data: ret });
                    if (that.props.data.tableKey === "2" || that.props.data.tableKey === undefined) {
                        that.setState({ BtnAgreeDisplay: 'none' })
                    } else {
                        that.setState({ BtnAgreeDisplay: 'inline' })
                    }
                    this.onClickApprove(false);
                    //归档才显示打印和导出按钮
                    // if(ret.PRE_MEETING_STATUS==5){
                    //     this.setState({ isFinished: 'inline' })
                    // }
                }
            }
        });
    }

    onTableBtnExport() {
        const enums = this.props.data.enums ? this.props.data.enums : this.props.app.enums;
        let TableWrap = document.getElementById('tableId' + this.props.data.id);
        let Table = TableWrap.getElementsByTagName('table')[0];
        const wb = XLSX.utils.table_to_book(Table);
        XLSX.writeFile(wb, "设备检测检验记录.xlsx")
    }

    onClickApprove = (appVisible) => {
        const newtmpData = {
            data: { id: this.props.data.id, isShow: true, key: guid(), param: this.props.data.param, appVisible: appVisible, BtnAgreeDisplay: 'inline' },
            formCode: "PF123",
        }
        this.setState({
            tmpData: newtmpData,
        });
    }
    render() {
        const { data } = this.state;
        const enums = this.props.data.enums ? this.props.data.enums : this.props.app.enums;
        // let aaa = Math.random();
        return <div>
            <div style={{ padding: '10px' }}>
                <Button onClick={() => this.onClickApprove(true)} style={{ marginRight: '8px' }} icon="export">审批详情</Button>
                <ReactToPrint
                    trigger={() => <Button style={{ marginLeft: '8px', display: data && data.IS_PUBLISH === 5 ? "inline" : "none" }} type={'default'} icon={'printer'} >打印</Button>}
                    content={() => this.componentRef} pageStyle={"#tableId" + this.props.data.id + " { padding:0 40px;} img{width :120px}"}
                />
                <Button onClick={() => this.onTableBtnExport()} icon="export" style={{ marginLeft: '8px', display: data && data.IS_PUBLISH === 5 ? "inline" : "none" }}>导出</Button>
                {/* <Button type="primary" style={{marginLeft: '8px', display: this.state.BtnAgreeDisplay }} onClick={() => this.onTableBtnAgree()} icon="check" >已阅</Button> */}
            </div>
            <div ref={el => (this.componentRef = el)} style={{ padding: '20px' }} id={'tableId' + this.props.data.id}>
                <h1 style={{ textAlign: 'center', margin: '15px' }}>设备检测检验记录</h1>
                {
                    data ?
                        <div>
                            <Descriptions size="middle" bordered className={stylesStep.description}>
                                <Descriptions.Item label="检测检验时间">{moment(data.TIME).format('YYYY-MM-DD')}</Descriptions.Item>
                                <Descriptions.Item label="责任部门">{data.Nav_Department ? data.Nav_Department.NAME : ''}</Descriptions.Item>
                                <Descriptions.Item label="责任人员">{data.Nav_User ? data.Nav_User.NAME : ''}</Descriptions.Item>
                                <Descriptions.Item label="设备设施名称">{data.Nav_DeviceBase ? data.Nav_DeviceBase.NAME : ''}</Descriptions.Item>
                                <Descriptions.Item label="规格/型号">{data.SPEC}</Descriptions.Item>
                                <Descriptions.Item label="设备设施编号">{data.MACHINE_CODE}</Descriptions.Item>
                                <Descriptions.Item label="设备设施位置">{data.POSITION}</Descriptions.Item>
                                <Descriptions.Item label="检测检验结果">{enums.DMInspectionResultEnum.enums[data.RESULT]}</Descriptions.Item>
                                <Descriptions.Item label="检测检验机构">{data.MECHANISM}</Descriptions.Item>
                                <Descriptions.Item label="检测检验资质">{data.QUALIFICATION}</Descriptions.Item>
                                <Descriptions.Item label='检测检验报告'>
                                    <div>{
                                        data.Nav_Files && data.Nav_Files.map((item, i) => {
                                            return <tr><a title={item.Nav_ImgFile.FILE_NAME} target='_blank' href={config.picServerHost + item.Nav_ImgFile.Nav_File.FILE_PATH} >{item.Nav_ImgFile.FILE_NAME} </a></tr>
                                        })
                                    }</div></Descriptions.Item>
                            </Descriptions>
                        </div> : null
                }
                <FormPage {...this.state.tmpData} />
            </div>
        </div>
    }

}

export default connect(({ login, app }) => ({ login, app }))(DM012ShowPrint) 